
var BookwyrmBootstrapper =
{
    newWindow: function ()
    {
        bookwyrm_prefs = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService)
                                .getBranch("bookwyrm.");

        // first time in, move windows icons
        var firstLoad;

        try
        {
            firstLoad = bookwyrm_prefs.getBoolPref("firstload");
        }
        catch(ex)
        {
            firstLoad = true;
            bookwyrm_prefs.setBoolPref("firstload", false);
        }

        if (firstLoad)
            this.copyIcons();

        // Open Bookwyrm window
        window.open("chrome://bookwyrm/content/manager.xul",
                    "Bookwyrm",
                    "chrome,resizable,toolbar,menubar");
    },

    getExtDefaultsPath: function ()
    {
        var p;
        var NSIFILE = Components.interfaces.nsIFile;
        var dirLocator = Components.classes["@mozilla.org/file/directory_service;1"]
                .getService(Components.interfaces.nsIProperties);
        var p = dirLocator.get("ProfD", NSIFILE).path;
        var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                                 .createInstance(Components.interfaces.nsILocalFile);
        dirLocal.initWithPath(p);
        dirLocal.append("extensions");
        dirLocal.append("{c2c1f16b-b212-47e8-a9e5-edc6d0337f60}");
        dirLocal.append("defaults");
        if (dirLocal.exists() && dirLocal.isDirectory())  {  // Fx and Tb
          return dirLocal.path;
        }
        else  { // seamonkey
          p = dirLocator.get("ProfDefNoLoc", NSIFILE).path;
          dirLocal.initWithPath(p);
          dirLocal.append("chrome");
          if (dirLocal.exists() && dirLocal.isDirectory())
            return dirLocal.path;
        }
        return null;
    },
    
    getIconsDefaultPath: function ()
    {
        var p;
        var NSIFILE = Components.interfaces.nsIFile;
        var dirLocator = Components.classes["@mozilla.org/file/directory_service;1"]
                .getService(Components.interfaces.nsIProperties);
        var p = dirLocator.get("AChrom", NSIFILE).path;
        var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                                 .createInstance(Components.interfaces.nsILocalFile);
        dirLocal.initWithPath(p);
        dirLocal.append("icons");
        dirLocal.append("default");
        return dirLocal.path;
    },

    copyIcons: function ()
    {
        var iconFiles = ["manager-window.ico", "manager-window.xpm"];
        var iconsDefaultsDir = this.getIconsDefaultPath();
        var extDefaultsDir = this.getExtDefaultsPath();
        
        var iconFile = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);

        for (i = 0; i < iconFiles.length; i++)
        {
            iconFile.initWithPath(iconsDefaultsDir);
            iconFile.append(iconFiles[i]);

            if (iconFile && !iconFile.exists())
            {
                // move it
                var theIconFile = Components.classes["@mozilla.org/file/local;1"]
                                 .createInstance(Components.interfaces.nsILocalFile);
                theIconFile.initWithPath(extDefaultsDir);
                theIconFile.append(iconFiles[i]);
                theIconFile.copyTo(iconFile.parent, iconFile.leafName);
            }
        }
    }
};

function toBookwyrm()
{
	BookwyrmBootstrapper.newWindow();
}


